## qca2 2.0.0~beta7

=== CMakeLists.txt ===
PROJECT(QCA)

OPTION(BUILD_TESTS "Create test" ON)

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )

set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Directory where lib will install")

set(PKGCONFIG_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/pkgconfig/" CACHE STRING "Base directory for pkgconfig files")

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules" )

find_package(Qt4 REQUIRED)

if (APPLE)
   find_package(Carbon REQUIRED)
   set(CMAKE_INSTALL_NAME_DIR ${LIB_INSTALL_DIR})
   set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif (APPLE)

if (CMAKE_COMPILER_IS_GNUCXX)
   if (CMAKE_SYSTEM_NAME MATCHES Linux)
     add_definitions (-D_BSD_SOURCE)
     set ( CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wno-long-long -ansi -Wundef -Wcast-align -Werror-implicit-function-declaration -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -Wmissing-format-attribute -fno-common")
     set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -ansi -Wundef -Wcast-align -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -fno-check-new -fno-common")
   endif (CMAKE_SYSTEM_NAME MATCHES Linux)
endif (CMAKE_COMPILER_IS_GNUCXX)

add_definitions (${QT_DEFINITIONS})
INCLUDE_DIRECTORIES(include/QtCrypto/ ${QT_INCLUDES})

# Always include srcdir and builddir in include path
# This saves typing ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY} in about every subdir
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# put the include dirs which are in the source or build tree
# before all other include dirs, so the headers in the sources
# are prefered over the already installed ones
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

SET(qca_INCLUDEDIR "${CMAKE_CURRENT_SOURCE_DIR}/include" )
SET(LIBRARY_OUTPUT_PATH "${CMAKE_BINARY_DIR}/lib${LIB_SUFFIX}" )

set(qca_PLUGINSDIR "${QT_PLUGINS_DIR}/crypto/")
MESSAGE(STATUS "Plugins will be installed to " ${qca_PLUGINSDIR})

include(QcaMacro)

MESSAGE(STATUS "Checking for certstore..")
# fixme add OR mac
IF( WIN32 )
# USE BUILTIN
ELSE ( WIN32 )
  IF ( ENV{QC_CERTSTORE_PATH} )
    IF(EXISTS ENV{QC_CERTSTORE_PATH})
      SET( qca_CERTSTORE $ENV{QC_CERTSTORE_PATH})
    ELSE(EXISTS ENV{QC_CERTSTORE_PATH})
		  # path to try
    ENDIF(EXISTS ENV{QC_CERTSTORE_PATH})
  ELSE( ENV{QC_CERTSTORE_PATH} )
    SET( toTry
      "/etc/ssl/certs/ca-certificates.crt"
      "/usr/share/ssl/cert.pem"
      "/usr/share/ssl/certs/ca-bundle.crt"
      "/etc/pki/tls/cert.pem"
      "/usr/share/curl/curl-ca-bundle.crt"
    )
    FOREACH (_current_try ${toTry})
      IF(EXISTS ${_current_try})
        SET( qca_CERTSTORE ${_current_try})
      ENDIF(EXISTS ${_current_try})
    ENDFOREACH (_current_try)
  ENDIF( ENV{QC_CERTSTORE_PATH} )
ENDIF(WIN32)

IF (qca_CERTSTORE)
  MESSAGE(STATUS "Found system certstore")
ELSE (qca_CERTSTORE)
  MESSAGE(STATUS "Using built in certstore.")
  SET( qca_CERTSTORE "${CMAKE_CURRENT_SOURCE_DIR}/certs/rootcerts.pem")
  # note that INSTALL_FILES targets are relative to the current installation prefix...
  INSTALL_FILES( "/certs" FILES "${CMAKE_CURRENT_SOURCE_DIR}/certs/rootcerts.pem" )
ENDIF (qca_CERTSTORE)
MESSAGE(STATUS "certstore path: " ${qca_CERTSTORE})
ADD_DEFINITIONS( -DQCA_SYSTEMSTORE_PATH="\\\"${qca_CERTSTORE}\\\"" )


SET( private_HEADERS ${qca_INCLUDEDIR}/QtCrypto/qca_plugin.h ${qca_INCLUDEDIR}/QtCrypto/qca_systemstore.h )

SET( public_HEADERS 
  ${qca_INCLUDEDIR}/QtCrypto/qca.h
  ${qca_INCLUDEDIR}/QtCrypto/qcaprovider.h
  ${qca_INCLUDEDIR}/QtCrypto/QtCrypto
  ${qca_INCLUDEDIR}/QtCrypto/qca_export.h
	${qca_INCLUDEDIR}/QtCrypto/qca_support.h
	${qca_INCLUDEDIR}/QtCrypto/qca_tools.h
	${qca_INCLUDEDIR}/QtCrypto/qca_core.h
	${qca_INCLUDEDIR}/QtCrypto/qca_textfilter.h
	${qca_INCLUDEDIR}/QtCrypto/qca_basic.h
	${qca_INCLUDEDIR}/QtCrypto/qca_publickey.h
	${qca_INCLUDEDIR}/QtCrypto/qca_cert.h
	${qca_INCLUDEDIR}/QtCrypto/qca_keystore.h
	${qca_INCLUDEDIR}/QtCrypto/qca_securelayer.h
	${qca_INCLUDEDIR}/QtCrypto/qca_securemessage.h
	${qca_INCLUDEDIR}/QtCrypto/qpipe.h )

SET( qca_HEADERS ${private_HEADERS} ${public_HEADERS} )

#install public headers only
INSTALL(FILES ${public_HEADERS} DESTINATION "${CMAKE_INSTALL_PREFIX}/include/QtCrypto")

INCLUDE_DIRECTORIES(${QT_QTCORE_INCLUDE_DIR} "${qca_INCLUDEDIR}/QtCrypto")

CONFIGURE_FILE("qca.pc.cmake" "${CMAKE_BINARY_DIR}/qca.pc" @ONLY)
INSTALL(FILES "${CMAKE_BINARY_DIR}/qca.pc" DESTINATION ${PKGCONFIG_INSTALL_PREFIX})

CONFIGURE_FILE("crypto.prf.cmake" "${CMAKE_BINARY_DIR}/crypto.prf" @ONLY)
INSTALL(FILES "${CMAKE_BINARY_DIR}/crypto.prf" DESTINATION ${CMAKE_INSTALL_PREFIX}/mkspecs/features)

add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(plugins)
if(BUILD_TESTS)
	ENABLE_TESTING()
        add_subdirectory(unittest)
        add_subdirectory(examples)
endif(BUILD_TESTS)

=== src/CMakeLists.txt ===

# base source files


SET( nonmoc_SOURCES
	qca_tools.cpp
	qca_plugin.cpp
	qca_textfilter.cpp
	qca_basic.cpp
	support/logger.cpp
)

SET( moc_SOURCES
	qca_core.cpp
	qca_publickey.cpp
	qca_keystore.cpp
	qca_securelayer.cpp
	qca_securemessage.cpp
	qca_default.cpp
	qca_cert.cpp
	support/qpipe.cpp
	support/console.cpp 
	support/synchronizer.cpp
	support/dirwatch.cpp
	support/syncthread.cpp
)

IF (Q_WS_X11)
  SET( nonmoc_SOURCES ${nonmoc_SOURCES} qca_systemstore_flatfile.cpp )
ENDIF(Q_WS_X11)

IF (WIN32)
  SET( moc_SOURCES ${moc_SOURCES} qca_systemstore_win.cpp )
ENDIF(WIN32)

if(APPLE)
  set( nonmoc_SOURCES ${nonmoc_SOURCES} qca_systemstore_mac.cpp)
endif(APPLE)

# Support files
#SET( qca_HEADERS ${qca_HEADERS} support/dirwatch/dirwatch_p.h )

# Botan tools
SET( botan_BASE botantools/botan )


INCLUDE_DIRECTORIES(${QT_QTCORE_INCLUDE_DIR} support ${botan_BASE} )

ADD_DEFINITIONS(
	-DBOTAN_TYPES_QT
	-DBOTAN_NO_INIT_H
	-DBOTAN_NO_CONF_H
	-DBOTAN_TOOLS_ONLY
	-DBOTAN_MINIMAL_BIGINT
)

ADD_DEFINITIONS(
  -DBOTAN_MP_WORD_BITS=32
  -DBOTAN_KARAT_MUL_THRESHOLD=12
  -DBOTAN_KARAT_SQR_THRESHOLD=12
  -DBOTAN_EXT_MUTEX_QT
)
if(WIN32)
   ADD_DEFINITIONS( -DQCA_MAKEDLL )
endif(WIN32)

if(UNIX)
   ADD_DEFINITIONS( -DBOTAN_EXT_ALLOC_MMAP)
endif(UNIX)

SET( botan_SOURCES
	${botan_BASE}/util.cpp
	${botan_BASE}/exceptn.cpp
	${botan_BASE}/mutex.cpp
	${botan_BASE}/mux_qt/mux_qt.cpp
	${botan_BASE}/charset.cpp
	${botan_BASE}/defalloc.cpp
	${botan_BASE}/mp_comba.cpp
	${botan_BASE}/mp_mul.cpp
	${botan_BASE}/mp_shift.cpp
	${botan_BASE}/mp_misc.cpp
	${botan_BASE}/divide.cpp
	${botan_BASE}/big_base.cpp
	${botan_BASE}/big_code.cpp
	${botan_BASE}/big_io.cpp
	${botan_BASE}/big_ops2.cpp
	${botan_BASE}/big_ops3.cpp
	${botan_BASE}/bit_ops.cpp
	${botan_BASE}/libstate.cpp
	${botan_BASE}/mem_pool.cpp
	${botan_BASE}/modules.cpp
	${botan_BASE}/mp_asm.cpp
	${botan_BASE}/mp_mulop.cpp
	${botan_BASE}/parsing.cpp
)

IF (UNIX)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_unix/mlock.cpp)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/alloc_mmap/mmap_mem.cpp)
ENDIF (UNIX)

IF(WIN32)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_win32/mlock.cpp)
ENDIF(WIN32)

MY_AUTOMOC( moc_SOURCES )
SET( SOURCES ${SOURCES} ${moc_SOURCES} ${nonmoc_SOURCES} )

SET( SOURCES ${SOURCES} ${botan_SOURCES})

qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_core.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_cert.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_keystore.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qcaprovider.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_publickey.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_securelayer.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_securemessage.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qca_support.h")
qt4_wrap_cpp( SOURCES "${qca_INCLUDEDIR}/QtCrypto/qpipe.h")

ADD_LIBRARY(qca SHARED ${SOURCES})
TARGET_LINK_LIBRARIES(qca ${QT_QTCORE_LIBRARY})

if(WIN32)
	TARGET_LINK_LIBRARIES(qca crypt32)
endif(WIN32)	

if(APPLE)
   set(CARBON_LIBRARY_SECURITY "-framework Security")
   TARGET_LINK_LIBRARIES(qca ${CARBON_LIBRARY} ${CARBON_LIBRARY_SECURITY})
endif(APPLE)

set_target_properties(qca PROPERTIES VERSION 2.0.0 SOVERSION 2 )

INSTALL(TARGETS qca DESTINATION ${LIB_INSTALL_DIR})

=== unittest/CMakeLists.txt ===
ENABLE_TESTING()
add_subdirectory(base64unittest)
add_subdirectory(bigintunittest)
add_subdirectory(certunittest)
add_subdirectory(cipherunittest)
add_subdirectory(clientplugin)
add_subdirectory(cms)
add_subdirectory(dsaunittest)
#add_subdirectory(filewatchunittest)
add_subdirectory(hashunittest)
add_subdirectory(hexunittest)
add_subdirectory(kdfunittest)
add_subdirectory(keybundle)
add_subdirectory(keygenunittest)
add_subdirectory(keylengthunittest)
add_subdirectory(keystore)
add_subdirectory(macunittest)
add_subdirectory(metatype)
#add_subdirectory(pgpunittest)
add_subdirectory(pkits)
add_subdirectory(randomunittest)
add_subdirectory(rsaunittest)
add_subdirectory(securearrayunittest)
add_subdirectory(staticunittest)
add_subdirectory(symmetrickeyunittest)
add_subdirectory(tls)
add_subdirectory(velox)

=== tools/qcatool/CMakeLists.txt ===
project(qcatool)

set(qcatool_moc_SRCS main.cpp)

MY_AUTOMOC( qcatool_moc_SRCS )

set(qcatool_bin_SRCS ${qcatool_moc_SRCS})  

add_executable(qcatool ${qcatool_bin_SRCS})

target_link_libraries( qcatool qca ${QT_QTGUI_LIBRARY})

install(TARGETS qcatool DESTINATION bin)

=== unittest/certunittest/CMakeLists.txt ===
ENABLE_TESTING()

set(certunittest_bin_SRCS certunittest.cpp)

MY_AUTOMOC( certunittest_bin_SRCS )

add_executable(certunittest ${certunittest_bin_SRCS} )

target_link_libraries( certunittest qca ${QT_QTTEST_LIBRARY})

FOREACH( testFileName RootCAcert.pem 76.pem altname.pem csr1.pem 
	 GoodCACRL.pem ov-root-ca-cert.crt User.pem user2goodcert.pem xmppcert.pem 
	 Server.pem servergood2cert.pem xmppcert.pem newreq.pem
	 QualitySSLIntermediateCA.crt RootCA2cert.pem Test_CRL.crl )
   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/certs/${testFileName} ${CMAKE_CURRENT_BINARY_DIR}/certs/${testFileName} COPYONLY)
ENDFOREACH( testFileName )

ADD_TEST(Certificate ${EXECUTABLE_OUTPUT_PATH}/certunittest)

=== unittest/cms/CMakeLists.txt ===
ENABLE_TESTING()

set(cms_bin_SRCS cms.cpp)

MY_AUTOMOC( cms_bin_SRCS )

add_executable(cms ${cms_bin_SRCS} )

target_link_libraries( cms qca ${QT_QTTEST_LIBRARY})

FOREACH( testFileName RootCAcert.pem  Userkey.pem  User.pem )
   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${testFileName} ${CMAKE_CURRENT_BINARY_DIR}/${testFileName} COPYONLY)
ENDFOREACH( testFileName )

ADD_TEST(CryptographicMessageSyntax ${EXECUTABLE_OUTPUT_PATH}/cms)

=== unittest/hashunittest/CMakeLists.txt ===
ENABLE_TESTING()

set(hashunittest_bin_SRCS hashunittest.cpp)  

MY_AUTOMOC( hashunittest_bin_SRCS )

add_executable( hashunittest ${hashunittest_bin_SRCS} )

target_link_libraries( hashunittest qca ${QT_QTTEST_LIBRARY})

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/data/empty ${CMAKE_CURRENT_BINARY_DIR}/data/empty COPYONLY)

ADD_TEST(Hashing ${EXECUTABLE_OUTPUT_PATH}/hashunittest)

=== unittest/pgpunittest/CMakeLists.txt ===
ENABLE_TESTING()

set(pgpunittest_bin_SRCS pgpunittest.cpp)  

MY_AUTOMOC( pgpunittest_bin_SRCS )

add_executable(pgpunittest ${pgpunittest_bin_SRCS} )

target_link_libraries( pgpunittest qca ${QT_QTTEST_LIBRARY} )

FOREACH( testFileName pubring.gpg secring.gpg trustdb.gpg )
   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/keys1/${testFileName} ${CMAKE_CURRENT_BINARY_DIR}/keys1/${testFileName} COPYONLY)
ENDFOREACH( testFileName )

FOREACH( testFileName pubring.gpg trustdb.gpg )
   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/keys2/${testFileName} ${CMAKE_CURRENT_BINARY_DIR}/keys2/${testFileName} COPYONLY)
ENDFOREACH( testFileName )

ADD_TEST(PGP ${EXECUTABLE_OUTPUT_PATH}/pgpunittest)

=== unittest/velox/CMakeLists.txt ===
ENABLE_TESTING()

set(veloxunittest_bin_SRCS veloxunittest.cpp)  

MY_AUTOMOC( veloxunittest_bin_SRCS )

add_executable(veloxunittest ${veloxunittest_bin_SRCS} )

target_link_libraries( veloxunittest qca ${QT_QTTEST_LIBRARY} ${QT_QTNETWORK_LIBRARY} )

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/root.crt ${CMAKE_CURRENT_BINARY_DIR}/root.crt COPYONLY)

ADD_TEST(ServerNameIndication ${EXECUTABLE_OUTPUT_PATH}/veloxunittest)

## qca2 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,11 +12,21 @@
 
 find_package(Qt4 REQUIRED)
 
+SET(QCA_LIB_MAJOR_VERSION "2")
+SET(QCA_LIB_MINOR_VERSION "0")
+SET(QCA_LIB_PATCH_VERSION "0")
+
+SET(QCA_LIB_VERSION_STRING "${QCA_LIB_MAJOR_VERSION}.${QCA_LIB_MINOR_VERSION}.${QCA_LIB_PATCH_VERSION}")
+
+
 if (APPLE)
    find_package(Carbon REQUIRED)
    set(CMAKE_INSTALL_NAME_DIR ${LIB_INSTALL_DIR})
    set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
 endif (APPLE)
+if (WIN32)
+ set(CMAKE_DEBUG_POSTFIX "d")
+endif (WIN32)
 
 if (CMAKE_COMPILER_IS_GNUCXX)
    if (CMAKE_SYSTEM_NAME MATCHES Linux)
@@ -111,8 +121,10 @@
 
 INCLUDE_DIRECTORIES(${QT_QTCORE_INCLUDE_DIR} "${qca_INCLUDEDIR}/QtCrypto")
 
-CONFIGURE_FILE("qca.pc.cmake" "${CMAKE_BINARY_DIR}/qca.pc" @ONLY)
-INSTALL(FILES "${CMAKE_BINARY_DIR}/qca.pc" DESTINATION ${PKGCONFIG_INSTALL_PREFIX})
+if(NOT WIN32)
+  CONFIGURE_FILE("qca.pc.cmake" "${CMAKE_BINARY_DIR}/qca.pc" @ONLY)
+  INSTALL(FILES "${CMAKE_BINARY_DIR}/qca.pc" DESTINATION ${PKGCONFIG_INSTALL_PREFIX})
+endif(NOT WIN32)
 
 CONFIGURE_FILE("crypto.prf.cmake" "${CMAKE_BINARY_DIR}/crypto.prf" @ONLY)
 INSTALL(FILES "${CMAKE_BINARY_DIR}/crypto.prf" DESTINATION ${CMAKE_INSTALL_PREFIX}/mkspecs/features)

=== examples/CMakeLists.txt ===
add_subdirectory(aes-cmac)
add_subdirectory(base64test)
add_subdirectory(certtest)
add_subdirectory(ciphertest)
add_subdirectory(cms)
# this is not meant to be added, because it introduces
# a dependency on QtGui.
# add_subdirectory(cmssigner)
add_subdirectory(eventhandlerdemo)
add_subdirectory(hashtest)
add_subdirectory(hextest)
add_subdirectory(keyloader)
add_subdirectory(mactest)
add_subdirectory(md5crypt)
add_subdirectory(providertest)
add_subdirectory(publickeyexample)
add_subdirectory(randomtest)
add_subdirectory(rsatest)
add_subdirectory(sasltest)
add_subdirectory(saslservtest)
add_subdirectory(ssltest)
add_subdirectory(sslservtest)
add_subdirectory(tlssocket)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,19 @@
+include(CheckIncludeFiles)
+CHECK_INCLUDE_FILES(sys/filio.h HAVE_SYS_FILIO_H)
+IF(HAVE_SYS_FILIO_H)
+  ADD_DEFINITIONS(-DHAVE_SYS_FILIO_H)
+ENDIF(HAVE_SYS_FILIO_H)
+
+INCLUDE(CheckCXXSourceCompiles)
+CHECK_CXX_SOURCE_COMPILES("
+# include <stdlib.h>
+# include <sys/mman.h>
+int main() { void *f = 0; return mlock(f,8); }
+" MLOCK_TAKES_VOID)
+if(NOT MLOCK_TAKES_VOID)
+  MESSAGE(STATUS "mlock(2) does not take a void *")
+  ADD_DEFINITIONS(-DMLOCK_NOT_VOID_PTR)
+endif(NOT MLOCK_TAKES_VOID)
 
 # base source files
 
@@ -130,11 +146,10 @@
    TARGET_LINK_LIBRARIES(qca ${CARBON_LIBRARY} ${CARBON_LIBRARY_SECURITY})
 endif(APPLE)
 
-set_target_properties(qca PROPERTIES VERSION 2.0.0 SOVERSION 2 )
+set_target_properties(qca PROPERTIES VERSION ${QCA_LIB_MAJOR_VERSION}.${QCA_LIB_MINOR_VERSION}.${QCA_LIB_PATCH_VERSION} SOVERSION ${QCA_LIB_MAJOR_VERSION} )
 
-INSTALL(TARGETS qca DESTINATION ${LIB_INSTALL_DIR})
-
-
-
- 
-
+INSTALL(TARGETS qca
+   LIBRARY DESTINATION ${LIB_INSTALL_DIR}
+   RUNTIME DESTINATION bin
+   ARCHIVE DESTINATION  ${LIB_INSTALL_DIR}
+)

=== tools/CMakeLists.txt ===
add_subdirectory(mozcerts)
add_subdirectory(qcatool)

=== unittest/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,8 @@
 add_subdirectory(keystore)
 add_subdirectory(macunittest)
 add_subdirectory(metatype)
-#add_subdirectory(pgpunittest)
+add_subdirectory(pgpunittest)
+add_subdirectory(pipeunittest)
 add_subdirectory(pkits)
 add_subdirectory(randomunittest)
 add_subdirectory(rsaunittest)

=== examples/aes-cmac/CMakeLists.txt ===
set(aes-cmac_bin_SRCS aes-cmac.cpp)  

add_executable(aes-cmac ${aes-cmac_bin_SRCS})

target_link_libraries( aes-cmac qca ${QT_QTGUI_LIBRARY})

=== examples/base64test/CMakeLists.txt ===
set(base64test_bin_SRCS base64test.cpp)  

add_executable(base64test ${base64test_bin_SRCS})

target_link_libraries( base64test qca ${QT_QTCORE_LIBRARY})

=== examples/certtest/CMakeLists.txt ===
set(certtest_bin_SRCS certtest.cpp)  

add_executable(certtest ${certtest_bin_SRCS})

target_link_libraries( certtest qca ${QT_QTGUI_LIBRARY})

=== examples/ciphertest/CMakeLists.txt ===
set(ciphertest_bin_SRCS ciphertest.cpp)  

add_executable(ciphertest ${ciphertest_bin_SRCS})

target_link_libraries( ciphertest qca ${QT_QTGUI_LIBRARY})

=== examples/eventhandlerdemo/CMakeLists.txt ===
set(eventhandlerdemo_bin_SRCS eventhandlerdemo.cpp)  

MY_AUTOMOC( eventhandlerdemo_bin_SRCS)

add_executable(eventhandlerdemo ${eventhandlerdemo_bin_SRCS})

target_link_libraries( eventhandlerdemo qca ${QT_QTCORE_LIBRARY})

=== examples/hashtest/CMakeLists.txt ===
set(hashtest_bin_SRCS hashtest.cpp)  

add_executable(hashtest ${hashtest_bin_SRCS})

target_link_libraries( hashtest qca ${QT_QTGUI_LIBRARY})

=== examples/publickeyexample/CMakeLists.txt ===
set(publickeyexample_bin_SRCS publickeyexample.cpp)  

add_executable(publickeyexample ${publickeyexample_bin_SRCS})

target_link_libraries( publickeyexample qca ${QT_QTGUI_LIBRARY})

## qca2 2.0.3

=== debian/changelog ===
qca2 (2.0.3-6) unstable; urgency=medium

  * Update the symbols file for gcc 4.9. Thanks to Sphinx Jiang for the
    initial patch. (Closes: #746895)

 -- Felix Geyer <fgeyer@debian.org>  Wed, 11 Jun 2014 16:54:40 +0200

qca2 (2.0.3-5) unstable; urgency=low

  * Team upload.
  * Change the section of qca2-utils from libs to utils.
  * Bump Standards-Version to 3.9.5, no changes required.
  * Update symbols file.

 -- Pino Toscano <pino@debian.org>  Sun, 08 Dec 2013 22:54:54 +0100

qca2 (2.0.3-4) unstable; urgency=low

  * Team upload.
  * Fix the symbols file.
  * Add pipeunittest_more_wait.diff to increase times of qWait() in the
    pipeunittest test (helps with Hurd).
  * Add patch hurd_msync.diff to temporarly ignore ENOSYS errors for Hurd's
    msync().

 -- Pino Toscano <pino@debian.org>  Mon, 04 Jun 2012 11:49:16 +0200

qca2 (2.0.3-3) unstable; urgency=low

  [ Felix Geyer ]
  * Modify CFLAGS and CXXFLAGS after including debian-qt-kde.mk so the
    changes are not overwritten.
  * Pass $CPPFLAGS to the build system.
  * Update symbols file.
  * Fix FTBFS with gcc 4.7. (Closes: #667339)
    - Add fix_build_gcc4.7.diff, cherry-picked from upstream.
  * Bump Standards-Version to 3.9.3, no changes needed.
  * Convert to multiarch.
    - Bump debhelper compat level to v9.
    - Move qcatool2 into the new binary package qca2-utils.
    - Mark libqca2 and libqca2-dbg as Multi-Arch: same.
  * Fix passing $LDFLAGS to the build system.
  * Pass build flags to qcatool2.
  * Remove confapp.pri in clean target.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Sat, 26 May 2012 18:30:41 +0200

qca2 (2.0.3-2) unstable; urgency=low

  [ Felix Geyer ]
  * Add Vcs-* fields.
  * Fix versioned dependency on arch-any package.

  [ Modestas Vainius ]
  * Add myself to Uploaders.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Thu, 23 Jun 2011 11:30:07 +0300

qca2 (2.0.3-1) unstable; urgency=low

  * New upstream release.

  [ Felix Geyer ]
  * Switch to source format 3.0 (quilt).
  * Switch debian/rules engine to dhmk.
  * Pass --no-separate-debug-info to configure and let dh_strip handle
    the debug symbol seperation.
  * Switch to debhelper compat level 7.
  * Simplify install files.
  * Don't install the TODO file.
  * Bump Standards-Version to 3.9.2.
    - Drop ancient Conflicts.
  * libqca2: don't suggest libqca2-plugin-pkcs11 as it doesn't exist.
  * Add myself as uploader.
  * Fix short description of libqca2-dbg.
  * Add missing ${misc:Depends}.
  * libqca2-dbg: recommend libqt4-dbg.
  * Build with -fvisibility=hidden -fvisibility-inlines-hidden.
    - Add define_qca_export.diff to define QCA_EXPORT as Q_DECL_EXPORT.
  * Disable broken unit test that fails if two subsequent random numbers are
    the same.
    - Add disable_randomunittest.diff
  * Add a symbols file.

  [ Modestas Vainius ]
  * Remove Matthew Rosewarne from Uploaders, R.I.P.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Mon, 30 May 2011 00:33:07 +0300

qca2 (2.0.2-1) unstable; urgency=low

  * New Upstream Version (Closes: Bug#529532)
  * Remove out-of-date VCS fields from debian/control
  * Move -dbg package to section 'debug'

 -- Jan Niehusmann <jan@debian.org>  Sat, 23 May 2009 16:20:39 +0200

qca2 (2.0.1-1) experimental; urgency=low

  * New upstream release.

  +++ Changes by Ana Beatriz Guerrero Lopez:
 
  * Build against Qt 4.4 in experimental. 

  +++ Changes by Matthew Rosewarne:

  * Create debug package.
  * Improve clean rule for apidocs.
  * Have libqca2 recommend ca-certificates.
  * Add VCS fields to control.
  * Bump Standards-Version to 3.8.0.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Mon, 21 Jul 2008 18:28:31 -0400

qca2 (2.0.0-4) unstable; urgency=low

  +++ Changes by Matthew Rosewarne:

  * Switch rules to CDBS.
  * Create API documentation package.
  * Install qmake data files in libqca2-dev.
  * Bump compat to 6.
  * Bump Standards-Version to 3.7.3.
  * Tweak package descriptions.
  * Add Homepage: to control.
  * Suggest qca2 plugins.
  * Add watch file.

  +++ Changes by Ana Beatriz Guerrero Lopez:

  * Update FSF address in the copyright file.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Sun, 10 Feb 2008 05:40:45 +0100

qca2 (2.0.0-3) unstable; urgency=low

  * Disable compilation of unit tests. As the plugins necessary to actually
    execute the tests are not available at compile time, and the compiled
    tests are not included in the packages, it's not actually useful to
    compile them in the first place. Additionally, some of the files need
    a huge amount of memory to compile and therefore take excessively long
    to compile on buildds with little memory.

 -- Jan Niehusmann <jan@debian.org>  Tue, 20 Nov 2007 12:16:44 +0100

qca2 (2.0.0-2) unstable; urgency=low

  * Upload to unstable

 -- Jan Niehusmann <jan@debian.org>  Sat, 27 Oct 2007 18:51:54 +0200

qca2 (2.0.0-1) experimental; urgency=low

  * New upstream release
  * Remove the bogous dependency on libxss-dev. This should have gone to psi,
    not qca2
  * libqca2-dev now depends on libqt4-dev (Closes: Bug#441264, Bug#441266)

 -- Jan Niehusmann <jan@debian.org>  Sun, 07 Oct 2007 15:02:41 +0200

qca2 (2.0.0~beta7-3) experimental; urgency=low

  * updated debian/copyright to mention all copyright holders and licenses

 -- Jan Niehusmann <jan@debian.org>  Tue, 14 Aug 2007 18:04:31 +0200

qca2 (2.0.0~beta7-2) experimental; urgency=low

  * Renamed the source package to qca2, to allow qca version 1 to stay in the
    archive in parallel to qca2. (Closes: Bug#435185)

 -- Jan Niehusmann <jan@debian.org>  Thu, 02 Aug 2007 18:03:25 +0200

qca (2.0.0~beta7-1) experimental; urgency=low

  * New upstream release
  * Some packaging cleanups (fixed lintian warnings etc.)
  * Added libxss-dev build dependency (like Ubuntu did a while ago)
  * removed libqt4-debug-dev from Build-Depends (Closes: Bug#407802, Bug#432619)
 


=== debian/control ===
Source: qca2
Priority: optional
Section: libs
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Jan Niehusmann <jan@debian.org>, Felix Geyer <fgeyer@debian.org>,
 Modestas Vainius <modax@debian.org>
Build-Depends: debhelper (>= 9), pkg-kde-tools (>= 0.12),
 libqt4-dev (>= 4.4.0), ca-certificates
Build-Conflicts: libqca2-dev, qca-dev
Standards-Version: 3.9.5
Homepage: http://delta.affinix.com/qca/
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-req/qca2.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/kde-req/qca2.git

Package: libqca2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Suggests: libqca2-plugin-cyrus-sasl, libqca2-plugin-gnupg, libqca2-plugin-ossl
Description: libraries for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.

Package: qca2-utils
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqca2 (= ${binary:Version})
Breaks: libqca2 (<< 2.0.3-3~)
Replaces: libqca2 (<< 2.0.3-3~)
Description: command line tool for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the command line tool for the Qt Cryptographic
 Architecture.

Package: libqca2-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libqca2 (= ${binary:Version})
Recommends: libqt4-dbg
Priority: extra
Description: debug symbols for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains debugging files used to investigate problems with
 the Qt Cryptographic Architecture libraries.

Package: libqca2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libqca2 (= ${binary:Version}), libqt4-dev (>= 4.4.0~)
Suggests: libqca2-doc (= ${source:Version})
Conflicts: qca-dev
Description: development files for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains development files for building software that uses the
 Qt Cryptographic Architecture.

Package: libqca2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: qt4-doc
Suggests: libqca2-dev (>= ${source:Version})
Description: API documentation for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains documentation for developers working with the
 Qt Cryptographic Architecture.

=== debian/watch ===
version=3

http://delta.affinix.com/download/qca/2.0/qca-(.*).tar\.bz2

## qca2 2.1.0

=== debian/changelog ===
qca2 (2.1.0-0ubuntu10) wily; urgency=medium

  * qca2-utils: Fix dependency on libqca2v5.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 01 Aug 2015 10:25:42 +0200

qca2 (2.1.0-0ubuntu9) wily; urgency=medium

  * Rename libqca2 to libqca2v5, follow-up to the libstdc++6 ABI
    transition. Addresses: #791253.
  * Add Breaks/Replaces to the old library package.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 30 Jul 2015 19:13:15 +0200

qca2 (2.1.0-0ubuntu8) wily; urgency=medium

  * Update symbols files.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Jul 2015 11:31:25 +0200

qca2 (2.1.0-0ubuntu7) wily; urgency=medium

  * Build using GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Jul 2015 10:36:59 +0200

qca2 (2.1.0-0ubuntu6) vivid; urgency=medium

  * Mark armhf and ppc64el specific symbols as optional.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 09 Mar 2015 19:43:21 +0100

qca2 (2.1.0-0ubuntu5) vivid; urgency=medium

  * Replace non-existing version 2.1.0+git20141126.2258 in the symbols
    file with 2.1.0.
  * Mark more symbols optional with GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 09 Mar 2015 18:38:48 +0100

qca2 (2.1.0-0ubuntu3) vivid; urgency=medium

  * Update symbols file

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 14 Jan 2015 18:32:16 +0100

qca2 (2.1.0-0ubuntu2) vivid; urgency=medium

  * New upstream release
    + This release merges the official plugins into the main package.
    + Deprecating these sources and their binaries:
      - qca2-plugin-gnupg
      - qca2-plugin-ossl
      - qca-cyrus-sasl
    + Build system was changed to git
    + Docs packages was removed as the source does not build documentation
    + New binary packages:
      - libqca2-plugins containing all plugins
      - libqca2-plugin-ossl
      - libqca2-plugin-gnupg
      - libqca2-plugin-cyrus-sasl
    + Added transitional packages for old plugins
  * Add kubuntu_ignore_filewatch_test.diff to ignore a test which fails in
    buildds but not for local build
  * Add kubuntu_mkspecs-dir.diff to install mkspecs to correct place

 -- Harald Sitter <apachelogger@kubuntu.org>  Sat, 22 Nov 2014 15:46:56 +0100

=== debian/control ===
Source: qca2
Priority: optional
Section: libs
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Jan Niehusmann <jan@debian.org>, Felix Geyer <fgeyer@debian.org>,
 Modestas Vainius <modax@debian.org>
Build-Depends: debhelper (>= 9), pkg-kde-tools (>= 0.12), cmake, pkg-config,
 libqt4-dev (>= 4.4.0), ca-certificates, libsasl2-dev, libssl-dev, doxygen
Build-Conflicts: qca-dev
Standards-Version: 3.9.6
Homepage: http://delta.affinix.com/qca/
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-req/qca2.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/kde-req/qca2.git

Package: libqca2-plugins
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: QCA plugins for libqca2
 This plugin provides cryptographic as well as helper plugins for Qt
 Cryptographic Architecture (QCA).

Package: libqca2v5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates, libqca2-plugins
Breaks: libqca2
Replaces: libqca2
Description: libraries for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.

Package: qca2-utils
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqca2v5 (= ${binary:Version})
Breaks: libqca2v5 (<< 2.0.3-3~)
Replaces: libqca2 (<< 2.0.3-3~)
Description: command line tool for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the command line tool for the Qt Cryptographic
 Architecture.

Package: libqca2-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libqca2v5 (= ${binary:Version})
Recommends: libqt4-dbg
Priority: extra
Description: debug symbols for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains debugging files used to investigate problems with
 the Qt Cryptographic Architecture libraries.

Package: libqca2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libqca2v5 (= ${binary:Version}), libqt4-dev (>= 4.4.0~)
Conflicts: qca-dev
Description: development files for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains development files for building software that uses the
 Qt Cryptographic Architecture.

# Transitional packages can be removed no sooner than May 2016.
# Next Kubuntu LTS is 16.04.
Package: libqca2-plugin-cyrus-sasl
Depends: libqca2-plugins, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: libqca2-plugin-gnupg
Depends: libqca2-plugins, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

Package: libqca2-plugin-ossl
Depends: libqca2-plugins, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/pkg-kde-tools/qt-kde-team/3/debian-qt-kde.mk
# Enable strict interdependencies
libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


override_dh_auto_configure:
	$(overridden_command)                                   -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DQT4_BUILD=true

override_dh_auto_build:
	$(overridden_command)

override_dh_auto_install:
	$(overridden_command)

override_dh_install:
	$(overridden_command) $(QT5_DH_EXCLUDE)

override_dh_strip:
	$(overridden_command) $(QT5_DH_EXCLUDE) --dbg-package=libqca2-dbg

=== debian/watch ===
version=3

http://delta.affinix.com/download/qca/(.*)/qca-(.*).tar\.bz2
